
/*	Notes:

	chrome://device-logs
	chrome://flags 
	CLICK Use Experimental Extension APIs to <Enable>

	(*) Since Chrome 42. 	ArrayBuffer	reportDescriptor	Raw device report descriptor (not available on Windows).

	lsusb -t

	HRT (High Resolution Timer) using window.performance.now();

	Objects, arrays, and functions operate as reference types, whereas numbers, Booleans, null, and undefined are known as primitive types.
	The moral of this story is to be aware that object, array, and function variable types are reference types, so any change to the original changes all copies.
	
*/	

/*
var pollForInput = function() {
    var size = +ui.inSize.value;
    isReceivePending = true;
    chrome.hid.receive(connection, function(reportId, data) {
      isReceivePending = false;
      logInput(new Uint8Array(data));
      if (ui.inPoll.checked) {
        setTimeout(pollForInput, 0);
      }
    });
  };
*/


	var Brandwatches =
	[	"Blank", "Custom", "Breitling", "Bvlgari", "Bulova", "Cartier", "Chaumet", "Chopard", "Hublot", "IWC", "Longines", "Omega", "Panerai", "Parmigiani",
		"Patek Philippe", "Audemars Piguet", "Rado", "Rolex", "TAG Heuer", "Tissot", "Raymond Weil", "Zenith"
	];

	var GiFpicture =
	[	"custb.gif", "custb.gif", "bbw01.gif", "bbw02.gif", "bbw03.gif", "cbw01.gif", "cbw02.gif", "cbw03.gif",
		"hbw01.gif", "ibw01.gif", "lbw01.gif", "obw01.gif",	"pbw01.gif", "pbw02.gif", "pbw03.gif", "pbw04.gif",
		"rbw01.gif", "rbw02.gif", "tbw01.gif", "tbw02.gif", "wbw01.gif", "zbw01.gif"
	];

	var Demowatches =
	[	"Brand", "Deuvalier", "Alpine", "Lemont", "Nautique", "Roland Garnier", "Marguet", "Van Linden & Losch", "Jerome Croix",
		"Philip Noir", "Mounier", "Sunlab", "Laurent Roi", "Bunkers", "Alain Brunel", "Antiques", "Valendome", "Stellar", "Renaud"
	];

	var Modelwatches =
	[	"Model", "Seasons", "Adventure", "Victory 64", "Surfer", "Gold Craft", "Leopard", "Explorer", "Racing Series", "Aviator",
		"Navigator", "Pulse II", "Radiance", "Sportif", "Avant", "Collectors Edition", "Tornado", "Chronos", "Titanium"
	];

	var Progmodes = [ "independent", "async master", "sync master", "async slave", "sync slave" ];

	const MAX_CUBES = 6;
//	const Test_HID1 = { vendorId: 5538, productId: 272 };
	const USB_HID_iNF =
	{ 	vendorId: 0x2504,
		productId: 0x405 };

	var Confglobal = [];
	var UsbHiD = "";

// Global
( function()
{	"use strict";

	var Saver = { netbox: 0, config: "", brand: "", model: "", rotate: "", rotations: 0, mode: "", blink: "" };
	var DemoDefs = "{ \"usbox\": 0, \"brand\": \"\",\"model\": \"\", \"rotate\": \"both\", \"rotations\": 1800, \"mode\":\"independent\", \"blink\": \"yes\" }";
	var Connection = [];
	var Cursor = 0;
	var StringData = "";
	var Netbox = { Wings: [], List: [] };
	var Probe = { netbox: 0 }; 
	var Status = { Devinfo: undefined, Path: "", Scan: 0, Setbox: 0, Length: 0, Visible: 0, ACK: false, Demo: false, UsbEject: false };
	var Echo = "";
	var Receive = "";
	var Polltimer = null;

//	var Console = console.prototype.apply.blind(console.info);
//	Console( "CHROME" );	

	var NameOfWatch = function( namewatch )
	{	return Brandwatches.indexOf( namewatch );

	};

	var StrOfArrayb = function( Arraybuffer )
	{	var Cnt = 0, Code, StrData = "";
		var Max = Arraybuffer.byteLength;
		var Uint8view = new Uint8Array(Arraybuffer);

		while( Cnt < Max )
		{	Code = Uint8view[Cnt++];
			StrData += String.fromCharCode(Code);
		}
	
		return StrData;
	};

	var ArraybOfStr = function( String2 )
	{	var BufArray = new ArrayBuffer(String2.length);
		var Uint8view = new Uint8Array(BufArray);

		for ( var Cnt=0; Cnt<String2.length; Cnt++ ) 
			Uint8view[Cnt] = String2.charCodeAt(Cnt);

		return BufArray;
	};


	var DetailsEvent = function()
	{	var auto, selection;
		var Boxes = document.getElementsByClassName( 'cube_image_css' );	

		if ( Boxes )
		{	for ( var dvp=0; dvp<Boxes.length; dvp++ ) 
				Boxes[dvp].src = "content/box_cube.gif";
		}

		if ( this.className === 'cube_image_css' )
			this.src = "content/selected_cube.gif";

		Status.Setbox = parseInt( this.name );
		var indexUp = Netbox.List.indexOf( Status.Setbox );

		if ( this.className === 'brand_image_css' )
			Boxes[indexUp].src = "content/selected_cube.gif";

		if ( this.className === 'watch_text_css' )
			Boxes[indexUp].src = "content/selected_cube.gif";

		selection = document.getElementById( 'brandname' );
		auto = NameOfWatch( Confglobal[1+indexUp].brand );

		if ( auto !== -1 )
			selection.options[auto].selected = true;
		else
		{	selection.options[0].selected = true;

			if ( document.getElementById( 'tooldemo' ).checked )
				selection.options[0].innerHTML = Confglobal[1+indexUp].brand;
			else	
				selection.options[0].innerHTML = "&nbsp;";
		}

		document.getElementById( 'modelwatch' ).value = Confglobal[1+indexUp].model;
		document.getElementById( 'rotations' ).value = Confglobal[1+indexUp].rotations;

		if ( document.getElementById( 'tooldemo' ).checked )
			document.getElementById( 'firmware' ).innerText = '1.0.0';
		else
			document.getElementById( 'firmware' ).innerText = Confglobal[1+indexUp].rev; 				//version;

		var selection = document.getElementById( 'blinks' );

		if ( Confglobal[1+indexUp].blink == 'yes' )
			selection.options[0].selected = true;
		else
			selection.options[1].selected = true;

		var rotation = document.getElementsByClassName( 'config_image_css' );

		if ( Confglobal[1+indexUp].rotate == 'cw' ) 
			rotation[0].src = "content/mini_rotate_right_green.gif";
		else
			rotation[0].src = "content/mini_rotate_right_white.gif";

		if ( Confglobal[1+indexUp].rotate == 'ccw' ) 
			rotation[1].src = "content/mini_rotate_left_green.gif";
		else
			rotation[1].src = "content/mini_rotate_left_white.gif";

		if ( Confglobal[1+indexUp].rotate == 'both' ) 
			rotation[2].src = "content/mini_rotate_both_green.gif";
		else
			rotation[2].src = "content/mini_rotate_both_white.gif";

		if ( document.getElementById( 'tooldemo' ).checked )
			var Batt = 300; 
		else		
			var Batt = Confglobal[1+indexUp].batt; 

		var Batt = Batt < 200 ? 0 : Batt - 200; 
				
		if ( Batt > 100 )
			Batt = 100;

		var vBatt = Batt.toString();

		if ( vBatt.length > 2 && vBatt !== "100" )
			document.getElementById( 'batt_level_css' ).innerText = vBatt.charAt(0) + "," + vBatt.substr(1,2) + "v";
		else			
		{	document.getElementById( 'batt_meter' ).value = vBatt;
			document.getElementById( 'batt_level_css' ).innerText = vBatt + "%";
		}

		selection = document.getElementById( 'function' );
		auto = Progmodes.indexOf( Confglobal[1+indexUp].mode );

		if ( Netbox.List.length > 1 ) 
		{	for ( var Lst=1; Lst<5; Lst++ ) 
				selection.options[Lst].disabled = false;		 

			if ( auto === -1 )
				selection.options[0].selected = true;		
			else
				selection.options[auto].selected = true;
		}
		else
		{	selection.options[0].selected = true;		

			for ( var Lst=1; Lst<5; Lst++ ) 
				selection.options[Lst].disabled = true;		 
		}
	};

	var BrandsEvent = function( Contents )
	{	if ( Status.Setbox )
		{	var indexUp = Netbox.List.indexOf( Status.Setbox );
			var iWatch = document.getElementById( 'brandname' );

			iWatch.style.display = 'inline-block';

			var auto = NameOfWatch( Contents );
			var uList = document.getElementById( 'watch_ulist' );

			if ( Contents && auto == -1 )
			{	if ( document.getElementById( 'tooldemo' ).checked )
				{	document.getElementById( 'brandname' ).options[0].selected = true;
					document.getElementById( 'brandname' ).options[0].innerHTML = Contents;
				}
				else
				{	var sOption = document.createElement( 'option' );
					sOption.value = "";
					sOption.innerHTML = Contents;		
					iWatch.appendChild( sOption );
	
					var Picks = iWatch.lastChild.index;
					iWatch.options[Picks].selected = true;
				}
			}

			if ( Contents )
				uList.getElementsByClassName( 'brand_css' )[indexUp].innerHTML = Contents;
			else
				uList.getElementsByClassName( 'brand_css' )[indexUp].innerHTML = "&nbsp;";

			Confglobal[1+indexUp].brand = Contents;
			uList = document.getElementById( 'brand_ulist' );

			if ( auto == -1 )
			{	if ( document.getElementById( 'tooldemo' ).checked )
					uList.getElementsByClassName( "brand_image_css" )[indexUp].src = "watch/demobw.gif";
				else
					uList.getElementsByClassName( "brand_image_css" )[indexUp].src = "watch/custb.gif";
			}
			else
				uList.getElementsByClassName( "brand_image_css" )[indexUp].src = "watch/" + GiFpicture[auto];

			var iWatch = document.getElementById( 'brandwatch' );
			iWatch.style.display = 'none';
		}
	};

	var CollectionEvent = function()
	{	if ( Status.Setbox )
		{	var indexUp = Netbox.List.indexOf( Status.Setbox );

			var Contents = document.getElementById( 'modelwatch' ).value;	
			var uList = document.getElementById( 'watch_ulist' );

			if ( Contents )
				uList.getElementsByClassName( 'collection_css' )[indexUp].innerHTML = Contents;
			else
				uList.getElementsByClassName( 'collection_css' )[indexUp].innerHTML = "&nbsp;";

			Confglobal[1+indexUp].model = Contents;
		}
	};


	var GetMeList = function()
	{	var Target = 1;

//		cubes [0,2]
		var Total = Netbox.Wings[0] + Netbox.Wings[1] + 1;

		if ( Confglobal.length )
		{	if ( Netbox.Wings[0] )
			{	if ( Confglobal.length < Netbox.Wings[0] )
					Target = ( Netbox.Wings[0] - Confglobal.length );

				if ( Netbox.Wings[0] === Confglobal.length )
					Target = Total;
			}

			if ( Netbox.Wings[1] )
			{	if ( Confglobal.length > Netbox.Wings[0] )
					Target = Confglobal.length;
			}

			if ( Total === Confglobal.length )
				Target = 0;
		}
		else
		{	if ( Netbox.Wings[1] )
				Target = Netbox.Wings[1];
	
			if ( Netbox.Wings[0] )
				Target = Netbox.Wings[0];
			else
				Target = Total;
		}

		return Target;
	};



	var GetJSON = function( Configure )
	{	Status.ACK = false;

		if ( Configure.usbox )
		{	if ( Configure.status )		
			{	if ( Configure.status == 'ready' )
				{	if ( Status.Scan )
						ResetVars();

					Netbox.Wings = Configure.cubes;
					Status.Length = GetMeList();
				}

				if ( Configure.status == 'ACK' )
					Status.ACK = true;

				return;
			}

			if (!Confglobal.length )
			{	Status.Visible = 0;
				Confglobal.push( Configure );			//	Index 0: used internally
			}

			Status.Length = GetMeList();
			var indexUp = Netbox.List.indexOf( Configure.usbox );

			if ( indexUp == -1 ) 
			{	var xUp = Status.Visible;
				var uList;

				Netbox.List.push( Configure.usbox );
				Confglobal[Confglobal.length] = Configure;

				uList = document.getElementsByClassName( 'cube_hotplug_css' );	
				uList[xUp].style.visibility = "";
				uList = document.getElementsByClassName( 'watch_text_css' );	
				uList[xUp].style.visibility = "";
				uList = document.getElementsByClassName( 'brand_css' );	
//				uList[xUp].style.visibility = "";

				if ( Configure.brand )
					uList[xUp].innerHTML = Configure.brand;
				else
					uList[xUp].innerHTML = "&nbsp;";

				uList = document.getElementsByClassName( 'collection_css' );
//				uList[xUp].style.visibility = "";

				if ( Configure.model )
					uList[xUp].innerHTML = Configure.model;
				else
					uList[xUp].innerHTML = "&nbsp;";

				uList = document.getElementsByClassName( 'brand_logo_css' );	
				uList[xUp].style.visibility = "";

				uList = document.getElementsByClassName( 'brand_image_css' );
				var auto = NameOfWatch( Configure.brand );

				if ( auto == -1 )
				{	if ( document.getElementById( 'tooldemo' ).checked )
						uList[xUp].src = "watch/demobw.gif";
					else
						uList[xUp].src = "watch/custb.gif";
				}
				else
					uList[xUp].src = "watch/" + GiFpicture[auto];

				uList = document.getElementsByClassName( 'cube_image_css' );	
				uList[xUp].name = Configure.usbox;
				uList = document.getElementsByClassName( 'brand_image_css' );	
				uList[xUp].name = Configure.usbox;
				uList = document.getElementsByClassName( 'watch_text_css' );	
				uList[xUp].name = Configure.usbox;

				Status.Visible++;

				var Titles = document.getElementsByClassName( 'watch_text_css' );	
				Titles[xUp].addEventListener( 'click', DetailsEvent );
				var Details = document.getElementsByClassName( 'brand_image_css' );	
				Details[xUp].addEventListener( 'click', DetailsEvent );
				var Details = document.getElementsByClassName( 'cube_image_css' );	
				Details[xUp].addEventListener( 'click', DetailsEvent );

				if (!Status.Length )
					Details[0].click();

				if ( Status.Visible > MAX_CUBES )  // Testing 2
				{	var Vertbar = document.getElementById( 'tree_css' );
					Vertbar.style.overflowY = 'scroll';
				}

			}
			else
			{	xUp = indexUp;
				Confglobal[1+xUp] = Configure;
			}
		}
		else
			console.info( "GetJSON> Unknown Config:", JSON.stringify( Configure ));
 

	};


	var Makesend = function( Query, Cube )
	{	var Host = { netbox: 0, config: "" };

		if ( Query === 'gets' )
		{	Host.config = Query;
			Host.netbox = Cube;
			SendHiD( Host );	
		}

		if ( Query === 'write' )
		{	var indexUp = Netbox.List.indexOf( Status.Setbox );
			var Configure = Confglobal[1+indexUp];
		
			Saver.netbox = Status.Setbox;
			Saver.config = Query;
			Saver.mode = Configure.mode;

			Saver.brand = Configure.brand;
			Saver.model = Configure.model;

			Saver.rotate = Configure.rotate;
			Saver.rotations = Configure.rotations;
			Saver.blink = Configure.blink;
			SendHiD( Saver );	
		}

	};


	var TestEcho = function( Coninfo, Guest )
	{	for ( var slot=0; slot<Connection.length; slot++ ) 
		{	if ( Connection[slot].Info.connectionId === Coninfo.connectionId )
			{	window.clearTimeout( Connection[slot].Pingtimer );
//				console.info( "TestEcho> Clear:", slot );
				if (!Status.Scan )
					document.getElementById( 'usbcoms' ).options[slot].selected = true;

				if ( Guest.status || Guest.usbox )
				{	Status.Path = Connection[slot].DeviD;
					Status.Devinfo = Coninfo;

					if ( Guest.status === 'enumerate' )
					{	Polltimer = window.setTimeout( ReceiveEvent, 50 );
						Connection[slot].Pingtimer = window.setTimeout( Connection[slot].CloseEvent, 2000 );
					}

					if ( Guest.status === 'ready' )		// ???
						Connection[slot].CloseEvent();
				}
			}
		}
	};

	var SplitsHiD = function()
	{	if ( chrome.runtime.lastError )
			console.info( "Send>", chrome.runtime.lastError.message );
		else
		{	var StringSplit = StringData.substring( Cursor );

			if ( StringSplit.length > 64 )
			{	var PacketOut = StringData.substring( Cursor, Cursor+64 );
				Cursor += 64;
				chrome.hid.send( UsbHiD.Info.connectionId, 0x0, ArraybOfStr(PacketOut), SplitsHiD );
			}
			else
			{	chrome.hid.send( UsbHiD.Info.connectionId, 0x0,  ArraybOfStr(StringSplit),
					function()		
					{	if ( chrome.runtime.lastError )
							console.info( "Split>", chrome.runtime.lastError.message );
						else
						{	
							Polltimer = window.setTimeout( ReceiveEvent, 10 );
						}
					} );
			}
		}
	};

	
	var SendHiD = function( Submit )
	{	if ( Status.Devinfo )			// Status.Device
		{	Receive = "";
			StringData = JSON.stringify( Submit ) + "\r\n";

			if ( StringData.length > 64 )
			{	Cursor = 64;

				var PacketOut = StringData.substring( 0, 64 );
				console.info( "Split>", StringData.length, StringData );
				chrome.hid.send( UsbHiD.Info.connectionId, 0x0, ArraybOfStr(PacketOut), SplitsHiD );
			}
			else
			{	chrome.hid.send( UsbHiD.Info.connectionId, 0x0,  ArraybOfStr(StringData),
					function()				
					{	if ( chrome.runtime.lastError )
							console.info( "Send>", chrome.runtime.lastError.message );
						else
						{	console.info( "Send>", StringData );
							Polltimer = window.setTimeout( ReceiveEvent, 10 );
						}
					} );
			}
			
			UsbHiD.Pingtimer = window.setTimeout( UsbHiD.CloseEvent, 2000 );
		}
	};


	var EchoEvent = function()
	{	chrome.hid.receive( UsbHiD.Info.connectionId,
			function( reportId, data )
			{	if ( chrome.runtime.lastError )
					console.info( "Ping>", chrome.runtime.lastError.message );
				else
				{	var Packet = StrOfArrayb( data );

					if ( Packet.lastIndexOf('\n') !== -1 )
					{	Echo += Packet.substring( 0, Packet.indexOf('\0'));
//					{	Echo += Packet.substring( 0, Packet.lastIndexOf('\n'));
						console.info( "Echo>", Echo );
//						console.info( "Echo> Length:", Packet.lastIndexOf('\n'));   
						TestEcho( UsbHiD.Info, JSON.parse(Echo));

						Echo = "";
					}
					else
					{	Polltimer = window.setTimeout( EchoEvent, 1 );
						Echo += Packet;
					}
				}
			} );
	};					


	var ReceiveEvent = function()
	{	chrome.hid.receive( UsbHiD.Info.connectionId,
			function( reportId, data )
			{	if ( chrome.runtime.lastError )
					console.info( "Send>", chrome.runtime.lastError.message );
				else
				{	var Packet = StrOfArrayb( data );

					if ( Packet.lastIndexOf('\n') !== -1 )
					{	Receive += Packet.substring( 0, Packet.indexOf('\0'));
						console.info( "Receive>", Receive.length, Receive );

//						if ( Status.UsbEject )
//							ReUpHiD( Connection[0].Info );		// ConnectEvent( pkinfo )
//						else
//						if ( Status.Length )
							GetJSON( JSON.parse(Receive));		// GetConfigure

						if ( Status.Length && !Status.ACK )
							Makesend( 'gets', Status.Length );					

						Receive = "";
					}
					else
					{	Polltimer = window.setTimeout( ReceiveEvent, 1 );
						Receive += Packet;
//						console.info( "Echo>", Packet, Packet.length );   

					}
				}
			} );
	};




//	Encapsulates an active device connection.
	var CubeHiD = function( name, HiD )
	{	var Pingtimer = null;

		var PingEvent = function()
		{	var Hello = { netbox: 0, ping: "hello?" };

			if ( Status.Scan )
				Hello.ping = "rescan";

			var StringData = JSON.stringify( Hello ) + "\r\n";

			chrome.hid.send( this.Info.connectionId, 0x0, ArraybOfStr(StringData),
				function()
				{	if ( chrome.runtime.lastError )
						console.info( "Ping>", chrome.runtime.lastError.message );
					else
					{	console.info( "Ping>", StringData );
						Polltimer = window.setTimeout( EchoEvent, 10 );
						return;
					}

				} );

			this.Pingtimer = window.setTimeout( this.CloseEvent, 2000 );

		};	


		var CloseEvent = function()
		{	if ( Status.UsbEject )
				console.info( "Close> Already disconnected" ); 
			else
			{	console.info( "Close> No answer... disconnecting", UsbHiD.Info.connectionId ); 

/*
				chrome.hid.disconnect( Connection[0].Info.connectionId, 
					function( status )
					{	if ( chrome.runtime.lastError )
							console.info( "Send>", chrome.runtime.lastError.message );
					} );		
		
				if ( Status.Devinfo )
				{	if ( Status.Devinfo.connectionId == Connection[0].Info.connectionId )
						Status.UsbEject = true;
				}
*/
			}
		};

		return { DeviD: name, Info: HiD, Pingtimer, 'CloseEvent': CloseEvent, 'PingEvent': PingEvent };
//		return { whois: name, iD: connectionId, Pingtimer: null, 'CloseEvent': CloseEvent, 'PingEvent': PingEvent };
	};


	var ConnectHiD = function( Cube )
	{	var Encapsulate = null;

		chrome.hid.connect( Cube, 
			function( Coninfo )
			{	if ( chrome.runtime.lastError )
					console.info( "Connect>", chrome.runtime.lastError.message );
				else
				{

				//	Connection = new Testdevice( Coninfo.deviceId, Coninfo.connectionId );
					Encapsulate = new CubeHiD( String(Cube), Coninfo );
					Connection.push(Encapsulate);
					var Last = Connection.lastIndexOf(Encapsulate);

					UsbHiD = Connection[Last];
//					Connection[Last].PingEvent();
					UsbHiD.PingEvent();
					console.info( "Connect> Index: [", Last, "]", Connection[Last] );
				}
			} );
	};


	var ReConnect = function( Cube )
	{	chrome.hid.connect( Cube, 
			function( Coninfo )
			{	if ( chrome.runtime.lastError )
					console.info( "Connect>", chrome.runtime.lastError.message );
				else
				{	Status.Devinfo = Coninfo;
					Status.UsbEject = false;
					SendHiD( Probe );
				}
			} );
	};

	var ReUpHiD = function( CiD )
	{	for ( var slot=0; slot<Connection.length; slot++ ) 
		{	if ( Connection[slot].Info.connectionId === CiD.connectionId )
			{	window.clearTimeout( Connection[slot].Pingtimer );
				console.info( "ReUpHiD> Clear:", slot );

				Status.Length = 0;
				Status.Devinfo = CiD;
				Status.UsbEject = false;

				document.getElementById( 'tooldemo' ).disabled = true;
				document.getElementById( 'status' ).innerText = "Connected";
				chrome.runtime.getBackgroundPage( function( Evtpage ) { Evtpage.ConnectDeviceiD = CiD.connectionId; } );
			}
		}
	
	};

	var SetUpHiD = function()
	{	chrome.hid.getDevices( USB_HID_iNF,
			function( Hidevinfo )
			{	var Draft = document.getElementById( 'usbcoms' );	

				if ( chrome.runtime.lastError )
					console.info( "Setup>", chrome.runtime.lastError.message );
				else
				{	if ( Hidevinfo.length )
					{	var Picks = -1;

						for (	var dvp=0; dvp<Hidevinfo.length; dvp++ ) 
						{	if ( Hidevinfo[dvp].vendorId === USB_HID_iNF.vendorId && Hidevinfo[dvp].productId === USB_HID_iNF.productId )
							{	var NewHiD = document.createElement( 'option' );
								NewHiD.value = "HID"; //DvListinfo[dvp].path;
								NewHiD.innerText = "usb HID";
//								NewHiD.innerText = "0x" + Hidevinfo[dvp].vendorId.toString(16); //) + StringHex(Hidevinfo[dvp].productId);
//								NewHiD.text = DvListinfo[dvp].displayName;

								if (!Hidevinfo[dvp].reportDescriptor.length )
									console.info( "Setup> No Descriptor Access!" );															
								else
									console.info( "Setup> Descriptor:", Hidevinfo[dvp].reportDescriptor );															

								if ( Draft )
								{	Draft.appendChild( NewHiD );
									Picks = Draft.lastChild.index;
								}
									
								ConnectHiD( Hidevinfo[dvp].deviceId );
								console.info( "Setup> Device:", Hidevinfo[dvp] );						
//								console.info( "Setup> Vendor:", Hidevinfo[dvp].vendorId, "Product:", Hidevinfo[dvp].productId );
							}
						}

						if ( Picks !== -1 && Draft.options[0].value == 'default' )
							Draft.removeChild(Draft[0]);		// None default
					}
					else
						console.info( "Setup> No Devices!" );						
				}
			} );
	};

     

	var DetectEvent = function()
	{	console.info( "Detect> New Device!" );

		if ( Status.Demo )
		{	document.getElementById( 'tooldemo' ).click();
			ResetVars();
		}

		SetUpHiD();
	};

	var UnplugEvent = function( Cube )
	{	console.info( "Unplug> Disconnected!", Cube );

		ResetVars();
		Connection = [];
		Status.Devinfo = null;

		var Draft = document.getElementById( 'usbcoms' );	
		while(Draft.firstChild)
			Draft.removeChild(Draft.firstChild);

//		chrome.hid.disconnect( Connection[0].Info.connectionId );
	};


	var ResetVars = function()
	{	Confglobal = [];
//		Connection = [];
		Netbox.List = [];

		Status.ACK = false;
		Status.Setbox = 0;

		var uHide = [];
		uHide[0] = document.getElementById( 'brand_ulist' );
		uHide[0] = uHide[0].getElementsByClassName( 'brand_logo_css' );
		uHide[1] = document.getElementById( 'watch_ulist' );
		uHide[1] = uHide[1].getElementsByClassName( 'watch_text_css' );
		uHide[2] = document.getElementById( 'cube_ulist' );
		uHide[2] = uHide[2].getElementsByClassName( 'cube_hotplug_css' );

		for ( var dvp=0; dvp<uHide[0].length; dvp++ ) 
		{	uHide[0][dvp].style.visibility = 'hidden';
			uHide[1][dvp].style.visibility = 'hidden';
			uHide[2][dvp].style.visibility = 'hidden';
		}

		var Boxes = document.getElementsByClassName( 'cube_image_css' );	

		if ( Boxes )
		{	for ( var dvp=0; dvp<Boxes.length; dvp++ ) 
				Boxes[dvp].src = "content/box_cube.gif";
		}
	};


	var ScanEvent = function()
	{	if ( Status.Demo )
		{	for ( var Cnt=1; Cnt<19; Cnt++ ) 
			{	var DemoList = JSON.parse( DemoDefs );				
				DemoList.usbox = Cnt;
				DemoList.brand = Demowatches[Cnt];		
				DemoList.model = Modelwatches[Cnt];		
				GetJSON( DemoList );	
			}

			var Details = document.getElementsByClassName( 'cube_image_css' );	
			Details[0].click();
		}
		else
		{	var Draft = document.getElementById( 'usbcoms' );	
			while(Draft.firstChild)
				Draft.removeChild(Draft.firstChild);
	
			ResetVars();
			Status.Scan += 1;

			if (!Status.UsbEject )		// Status.Close
			{	console.info( "Scan> ", Status.Devinfo );
				chrome.hid.disconnect( Status.Devinfo.connectionId,
					function ( status ) { } );		

//				Status.UsbEject = true;
			}

			SetUpHiD();
		}
	};



//	Main
	console.info( "Main>", navigator.platform );
	chrome.hid.onDeviceAdded.addListener( DetectEvent );
	chrome.hid.onDeviceRemoved.addListener( UnplugEvent );
//	Scan Devices
	SetUpHiD();


	var Jswitcher = function( language )
	{//	setCookie("Language", Language)
		var Headings = document.getElementsByTagName( 'h6' );
		var Labels = document.getElementsByTagName( 'label' );
		var Functions = document.getElementById( 'function' );	
		var Options = document.getElementById( 'brandname' );	
		var Inputs = document.getElementById( 'brandwatch' );	
	
		if ( language == 'Eng' ) 
		{//	Inputs.value = "Add a name";
			Options.options[1].innerHTML = "Add new brand";

			Headings[0].innerHTML = "RIGHT ROTATIONS";
			Headings[1].innerHTML = "LEFT ROTATIONS";
			Headings[2].innerHTML = "ROTATIONS <br> OFF";
			Headings[3].innerHTML = "GREEN LED";
			Headings[4].innerHTML = "RED LED";
			Headings[5].innerHTML = "LED OFF";

			Headings = document.getElementsByTagName( 'h3' );

			Headings[0].innerHTML = "TEST CENTER";
			Headings[1].innerHTML = "PROGRAMMING";

			Labels[3].innerHTML = "WATCH BRAND:";
			Labels[4].innerHTML = "WATCH MODEL:";
			Labels[5].innerHTML = "ROTATIONS PER DAY:";
			Labels[6].innerHTML = "LED FUNCTION:";
			Labels[7].innerHTML = "OPERATING MODE:";
			Labels[8].innerHTML = "WINDER FIRMWARE VERSION:";

			Functions[0].innerHTML = "Independent";
			Functions[1].innerHTML = "Master asynchrone";
			Functions[2].innerHTML = "Master  synchrone";
			Functions[3].innerHTML = "Slave asynchrone";
			Functions[4].innerHTML = "Slave synchrone";

			document.getElementById( 'blinks' )[0].innerHTML = "yes";	
			document.getElementById( 'blinks' )[1].innerHTML = "no";	

			Headings = document.getElementsByTagName( 'h5' );
		
			Headings[0].innerHTML = "RIGHT<br>ROTATIONS";
			Headings[1].innerHTML = "LEFT<br>ROTATIONS";
			Headings[2].innerHTML = "ALTERNATE";

			document.getElementById( 'configsave' ).value = "Save New Configuration";
			document.getElementById( 'defconfig' ).value = "Restore Default Configuration";
		}

		if ( language == 'Fra' )
		{//	Inputs.value = "Ajouter un nom";
			Options.options[1].innerHTML = "Ajouter une marque";
	
			Headings[0].innerHTML = "ROTATIONS <br> &Agrave; DROITE";
			Headings[1].innerHTML = "ROTATIONS <br> &Agrave; GAUCHE";
			Headings[2].innerHTML = "ROTATIONS <br> ARR&Ecirc;T";
			Headings[3].innerHTML = "LED VERT";
			Headings[4].innerHTML = "LED ROUGE";
			Headings[5].innerHTML = "LED ARR&Ecirc;T";

			Headings = document.getElementsByTagName( 'h3' );

			Headings[0].innerHTML = "TESTS";
			Headings[1].innerHTML = "PROGRAMMATION";

			Labels[3].innerHTML = "MARQUE:";
			Labels[4].innerHTML = "MOD&Egrave;LE:";
			Labels[5].innerHTML = "ROTATIONS PAR JOUR:";
			Labels[6].innerHTML = "LED FONCTION:";
			Labels[7].innerHTML = "MODE PROGRAMME:";
			Labels[8].innerHTML = "VERSION DU MICROCODE:";

			Functions[0].innerHTML = "Ind&eacute;pendant";
			Functions[1].innerHTML = "Ma&icirc;tre asynchrone";
			Functions[2].innerHTML = "Ma&icirc;tre synchrone";
			Functions[3].innerHTML = "Esclave asynchrone";
			Functions[4].innerHTML = "Esclave synchrone";

			document.getElementById( 'blinks' )[0].innerHTML = "oui";	
			document.getElementById( 'blinks' )[1].innerHTML = "non";	

			Headings = document.getElementsByTagName( 'h5' );

			Headings[0].innerHTML = "ROTATIONS <br> &Agrave; DROITE";
			Headings[1].innerHTML = "ROTATIONS <br> &Agrave; GAUCHE";
			Headings[2].innerHTML = "ALTERN&Eacute";

			document.getElementById( 'configsave' ).value = "Sauvegarder  Configuration";
			document.getElementById( 'defconfig' ).value = "Restaurer par D&eacute;faut";
		}
	};



	window.onload = function()
	{
//		DEMO
		document.getElementById( 'tooldemo' ).addEventListener( 'click',
			function()
			{
				if ( Status.Devinfo ||Status.Length )
					this.checked = false;
				else
				{
					if ( this.checked )
						document.getElementById( 'status' ).innerHTML = "Offline";
					else
					{	ResetVars();
						var Vertbar = document.getElementById( 'tree_css' );
						Vertbar.style.overflowY = 'hidden';
						document.getElementById( 'status' ).innerHTML = "Ready";
					}
				}

				Status.Demo = this.checked;
				console.info( "Demo>", Status.Setbox, Status.Length, Status.Demo );
			} );


//		PushButton SCAN
		document.getElementById( 'finder' ).addEventListener( 'click', ScanEvent );
//		Motor Turn RIGHT
		document.getElementById( 'motor-cw' ).addEventListener( 'click',
			function()
			{	if ( Status.Setbox && Status.Devinfo )		// Netbox.iD, Status.Device 
				{	var ButtonFace = document.getElementById( 'motor-cw' );
					ButtonFace.childNodes[1].src = "content/rotate_right_green.gif";
					ButtonFace = document.getElementById( 'motor-ccw' );
					ButtonFace.childNodes[1].src = "content/rotate_left_white.gif";

					Probe = { netbox: 0 };
					Probe.netbox = Status.Setbox;
					Probe[document.getElementById( 'motor-cw' ).name] = "on";			// Motor-Test: On

					Probe.state = [];
					Probe.state[0] = true; // document.getElementById( 'motor-cw' ).checked;
					Probe.state[1] = false; // document.getElementById( 'motor-ccw' ).checked;
					SendHiD( Probe );
				}
			} );

//		Motor Turn LEFT
		document.getElementById( 'motor-ccw' ).addEventListener( 'click',
			function()
			{	if ( Status.Setbox && Status.Devinfo )
				{	var ButtonFace = document.getElementById( 'motor-cw' );
					ButtonFace.childNodes[1].src = "content/rotate_right_white.gif";
					ButtonFace = document.getElementById( 'motor-ccw' );
					ButtonFace.childNodes[1].src = "content/rotate_left_green.gif";

					Probe = { netbox: 0 };
					Probe.netbox = Status.Setbox;
					Probe[document.getElementById( 'motor-ccw' ).name] = "on";			// Motor-Test: On

					Probe.state = [];
					Probe.state[0] = false; // document.getElementById( 'motor-cw' ).checked;
					Probe.state[1] = true; // document.getElementById( 'motor-ccw' ).checked;
					SendHiD( Probe );
				}
			} );

//		Motor STOP
		document.getElementById( 'motor-off' ).addEventListener( 'click',
			function()
			{	if ( Status.Setbox && Status.Devinfo )
				{	var ButtonFace = document.getElementById( 'motor-cw' );
					ButtonFace.childNodes[1].src = "content/rotate_right_white.gif";
					ButtonFace = document.getElementById( 'motor-ccw' );
					ButtonFace.childNodes[1].src = "content/rotate_left_white.gif";

					Probe = { netbox: 0 };
					Probe.netbox = Status.Setbox;
					Probe[document.getElementById( 'motor-off' ).name] = "off";
					SendHiD( Probe );
				}
			} );

//		Green LED
		document.getElementById( 'green-pilot' ).addEventListener( 'click',
			function()
			{	if ( Status.Setbox && Status.Devinfo )
				{	var ButtonFace = document.getElementById( 'green-pilot' );
					ButtonFace.childNodes[1].src = "content/green-light-on.gif";
					ButtonFace = document.getElementById( 'red-pilot' );
					ButtonFace.childNodes[1].src = "content/red-light-off.gif";

					Probe = { netbox: 0 };
					Probe.netbox = Status.Setbox;
					Probe[document.getElementById( 'green-pilot' ).name] = "on";

					Probe.state = [];
					Probe.state[0] = false; // document.getElementById( 'red-pilot' ).checked;
					Probe.state[1] = true; // document.getElementById( 'green-pilot' ).checked;
					SendHiD( Probe );
				}
			} );

//		Red LED
		document.getElementById( 'red-pilot' ).addEventListener( 'click',
			function()
			{	if ( Status.Setbox && Status.Devinfo )
				{	var ButtonFace = document.getElementById( 'green-pilot' );
					ButtonFace.childNodes[1].src = "content/green-light-off.gif";
					ButtonFace = document.getElementById( 'red-pilot' );
					ButtonFace.childNodes[1].src = "content/red-light-on.gif";

					Probe = { netbox: 0 };
					Probe.netbox = Status.Setbox;
					Probe[document.getElementById( 'red-pilot' ).name] = "on";

					Probe.state = [];
					Probe.state[0] = true; // document.getElementById( 'red-pilot' ).checked;
					Probe.state[1] = false; // document.getElementById( 'green-pilot' ).checked;
					SendHiD( Probe );
				}
			} );

//		Leds OFF
		document.getElementById( 'pilot-off' ).addEventListener( 'click',
			function()
			{	if ( Status.Setbox && Status.Devinfo )
				{	var ButtonFace = document.getElementById( 'green-pilot' );
					ButtonFace.childNodes[1].src = "content/green-light-off.gif";
					ButtonFace = document.getElementById( 'red-pilot' );
					ButtonFace.childNodes[1].src = "content/red-light-off.gif";

					Probe = { netbox: 0 };
					Probe.netbox = Status.Setbox;
					Probe[document.getElementById( 'pilot-off' ).name] = "off";

					Probe.state = [];
					Probe.state[0] = false; // document.getElementById( 'red-pilot' ).checked;
					Probe.state[1] = false; // document.getElementById( 'green-pilot' ).checked;
					SendHiD( Probe );
				}
			} );

		document.getElementById( 'brandname' ).addEventListener( 'change',
			function()
			{	if ( Status.Setbox )
				{	var Selection = this.options[this.selectedIndex];

					if ( Selection.value === '1' )
					{	this.style.display = 'none';

						var iWatch = document.getElementById( 'brandwatch' );
						iWatch.style.display = "inline-block";
						iWatch.focus();
					}
					else
						BrandsEvent( Selection.innerHTML );
				}
			} );

		document.getElementById( 'brandwatch' ).addEventListener( 'click',
			function()
			{	BrandsEvent( this.value );

			} );

		document.getElementById( 'brandwatch' ).addEventListener( 'keypress',
			function( Eventinfo )
			{	if ( Eventinfo.keyCode === 13 )		// ENTER_KEY
					BrandsEvent( this.value );
			} );       

		document.getElementById( 'modelwatch' ).addEventListener( 'click', CollectionEvent );

		document.getElementById( 'modelwatch' ).addEventListener( 'keypress',
			function( Eventinfo )
			{      if ( Eventinfo.keyCode === 13 )		// ENTER_KEY
					CollectionEvent();

			} );       

		document.getElementById( 'function' ).addEventListener( 'change',
			function()
			{	if ( Status.Setbox && Status.Devinfo )
				{	var indexUp = Netbox.List.indexOf( Status.Setbox );
					var auto = this.options.selectedIndex;
					Confglobal[1+indexUp].mode = Progmodes[auto];
				}	
			} );

		document.getElementById( 'rotations' ).addEventListener( 'change',
			function()
			{	var Edition = parseInt( document.getElementById( 'rotations' ).value );

				if ( Status.Devinfo )
				{	var indexUp = Netbox.List.indexOf( Status.Setbox );

					if ( Edition < 200 )
					{	if ( Edition < Confglobal[1+indexUp].rotations )
							document.getElementById( 'rotations' ).value = "0";

						if ( Edition > Confglobal[1+indexUp].rotations )
							document.getElementById( 'rotations' ).value = "200";
					}

					if ( Edition > 3000 )
						document.getElementById( 'rotations' ).value = "3000";

					Confglobal[1+indexUp].rotations = parseInt( document.getElementById( 'rotations' ).value );
				}
				else
				{	if ( Edition < 200 )
					{	if ( Edition < Saver.rotations )
							document.getElementById( 'rotations' ).value = "0";

						if ( Edition > Saver.rotations )
							document.getElementById( 'rotations' ).value = "200";
					}

					if ( Edition > 3000 )
						document.getElementById( 'rotations' ).value = "3000";

					Saver.rotations = parseInt( document.getElementById( 'rotations' ).value );
				}
			} );

		document.getElementById( 'blinks' ).addEventListener( 'change',
			function()
			{	if ( Status.Devinfo )
				{	var indexUp = Netbox.List.indexOf( Status.Setbox );
					var Edition = this.options[this.selectedIndex].value;
					Confglobal[1+indexUp].blink = Edition;
				}
			} );

		document.getElementById( 'rotate-cw' ).addEventListener( 'click',
			function()
			{	var ButtonFace = document.getElementsByClassName( 'config_image_css' );
				ButtonFace[0].src = "content/mini_rotate_right_green.gif";
				ButtonFace[1].src = "content/mini_rotate_left_white.gif";
				ButtonFace[2].src = "content/mini_rotate_both_white.gif";
				
				if ( Status.Setbox && Status.Devinfo )
				{	var indexUp = Netbox.List.indexOf( Status.Setbox );
					Confglobal[1+indexUp].rotate = 'cw';
				}
			} );

		document.getElementById( 'rotate-ccw' ).addEventListener( 'click',
			function()
			{	var ButtonFace = document.getElementsByClassName( 'config_image_css' );
				ButtonFace[0].src = "content/mini_rotate_right_white.gif";
				ButtonFace[1].src = "content/mini_rotate_left_green.gif";
				ButtonFace[2].src = "content/mini_rotate_both_white.gif";

				if ( Status.Setbox && Status.Devinfo )
				{	var indexUp = Netbox.List.indexOf( Status.Setbox );
					Confglobal[1+indexUp].rotate = 'ccw';
				}

			} );

		document.getElementById( 'rotate-both' ).addEventListener( 'click',
			function()
			{	var ButtonFace = document.getElementsByClassName( 'config_image_css' );
				ButtonFace[0].src = "content/mini_rotate_right_white.gif";
				ButtonFace[1].src = "content/mini_rotate_left_white.gif";
				ButtonFace[2].src = "content/mini_rotate_both_green.gif";

				if ( Status.Setbox && Status.Devinfo )
				{	var indexUp = Netbox.List.indexOf( Status.Setbox );
					Confglobal[1+indexUp].rotate = 'both';
				}
			} );

		document.getElementById( 'logotype_css' ).addEventListener( 'click',
			function()
			{	window.open( "http://www.swisskubik.com" ); 

			} );

//		PushButton SAVE
		document.getElementById( 'configsave' ).addEventListener( 'click',
			function()
			{	if (!Status.Demo && Status.Devinfo && Status.Setbox )
				{	if ( Status.UsbEject )
					{
/*
		{	if ( Status.Path )
			{	chrome.serial.connect( Status.Path,{ bitrate:115200, name:Status.Path }, function( Coninfo )
				{	if ( chrome.runtime.lastError	)
						console.log.info( chrome.runtime.lastError.message );

					Status.Close = false;
					Status.Device = Coninfo;
					ConfigEvent( 'write', Netbox.iD );
				} );
	
						}
						else
						console.info( "Chrome> No Path...", Status.Path );
*/
					}
					else
						Makesend( 'write', Status.Setbox );
				}

//		document.getElementById( 'status' ).innerText = "Saving";
			} );

		document.getElementById( 'defconfig' ).addEventListener( 'click',
			function()
			{	if ( Status.Setbox && Status.Devinfo )
				{	var indexUp = Netbox.List.indexOf( Status.Setbox );

//					Reset to Default Configuration
					Confglobal[1+indexUp].brand = "";
					Confglobal[1+indexUp].model = "";
					Confglobal[1+indexUp].rotations = 1900;
					Confglobal[1+indexUp].blink = 'yes';
					Confglobal[1+indexUp].rotate = 'both';
					Confglobal[1+indexUp].mode = Progmodes[0];

					var Details = document.getElementsByClassName( 'cube_image_css' );	
					Details[indexUp].click();

					var uList = document.getElementById( 'watch_ulist' );
					uList.getElementsByTagName( 'h2' )[indexUp].innerHTML = "&nbsp;";
					uList.getElementsByTagName( 'h4' )[indexUp].innerHTML = "&nbsp;";
					uList = document.getElementById( 'brand_ulist' );
					uList.getElementsByClassName( "brand_image_css" )[indexUp].src = "watch/custb.gif";
				}
			} );

		document.getElementById( 'usbcoms' ).addEventListener( 'change',
			function()
			{	if ( Status.Devinfo )
					console.info( "Work In Progress..." );
				else		
				{	Status.Path = this.options[this.selectedIndex].value;

					if ( Status.UsbEject )
						chrome.serial.connect( Status.Path, { bitrate:115200 }, ConnectEvent );
				}

				console.info( "Chrome> Connection:", Status.Path, Status.Scan, Status.Devinfo );
			} );

		document.getElementById( 'language' ).addEventListener( 'change',
			function()
			{	Jswitcher( this.options[this.selectedIndex].value );
		
			} );

		console.info( "OnLoad> Done" );
	};
	

} )();



/*
( function() { } ) ();

( function(obj) { } )(this);

var global = ( function() { return this; } ) ();

var main = ( function() {} ) ();
document.addEventListener( 'DOMContentLoaded', function() { var sensor = new main.HeartRateSensor();  sensor.init(); } );


//	if ( window.screen.width < window.outerWidth )
//	if ( window.screen.height < window.outerHeight )

//	var Vbar = document.getElementById( 'chrome_win' );
//	Vbar.style.overflowY = 'scroll';
*/





