
/*
	-Add "persistent": false to your manifest as shown above.
	- If your extension uses window.setTimeout() or window.setInterval(), switch to using the alarms API instead.
	  DOM-based timers won't be honored if the event page shuts down.
	- Similarly, other asynchronous HTML5 APIs like notifications and geolocation will not complete if the event page shuts down.
	  Instead, use equivalent extension APIs, like notifications.
	- If your extension uses, extension.getBackgroundPage, switch to runtime.getBackgroundPage instead.
	  The newer method is asynchronous so that it can start the event page if necessary before returning it.
*/

var ConnectDeviceiD;


function CreateEvent( CubeApp )					// iframe object
{
//	console.info( "Bkg> onCreate()" );

	CubeApp.onClosed.addListener( function()
	{
//		console.info( "Bkg> onClosed(", ConnectDeviceiD, ")" );

		if ( ConnectDeviceiD )
		{
			chrome.serial.disconnect( ConnectDeviceiD, function( status )
			{
				ConnectDeviceiD = 0;

				if ( chrome.runtime.lastError	)
		   			console.info( "Bkg>", chrome.runtime.lastError.message );
				
			} );
		}
	} );
}

chrome.app.runtime.onLaunched.addListener( function()
{ 
	chrome.app.window.create( 'index.html', { id:"WinCube", bounds: { width:840, height:720 }, resizable:false }, CreateEvent ); 
	console.info( "Bkg> onLaunched()" );
} );


chrome.runtime.onSuspend.addListener( function()
{
	console.info( "Bkg> onSuspend()");
} );







